/*-----------------------------------------
   OTH2.C -- Other procedures module #2
   Version date: 03.09.04
  -----------------------------------------*/


/*----------------------------------------------------------------------
COPYRIGHT 2003, 2005 PETER DAVIS
This file is part of "HMS Surprise - Frigate and brig Simulator for
Windows". That program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version. The file is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this file; if not, write to the Free Software Foundation,
Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
----------------------------------------------------------------------*/

#include <windows.h>
#include <commctrl.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "External.h" 

// Prototypes:
void   AdjustSails() ;
int    Beaufort (float) ;
void   DecrSail () ;
void   IncrSail () ;
void   MakeSail () ;
void   Pause () ;
void   ShowMessage () ;
void   ShowStatusMessage () ;
void   ShowYardShown () ;

extern void   CanShadow () ;
extern void   Recorder (int, int, int) ;
extern void   SailPlan () ;
extern int    Sgn (float) ;
extern void   ShowActualJibAngle () ;
extern void   ShowSelectedYardAngle (int) ;

/*-----------------------------------------
   AdjustSails
   Version date: 03.09.04
  -----------------------------------------*/
void AdjustSails ()
  {
  int    iI, iJ ;
  float  fBorderLine ;
  int    iThisSail ;
  int    xClick ;
  int    yClick ;
  float  fOffsetX ;
  int    iNrReefs ;
  BOOL   bSail ;
  int    iThisStatus ;
  float  f1, f2, f3, f4, fX1, fX2, fX3, fX4, fY1, fY2, fY3, fY4 ;
  float  fXFeet, fYFeet ;

  xClick = xClicks[0] ;
  yClick = yClicks[0] ;
  if (xClick < xOrgPixels)
    xClick = - (xOrgPixels-xClick) ;
  else
    xClick = xClick - xOrgPixels ;
  yClick = (cxChildPixels* 0.85) - yClick;

  fXFeet =  xClick * (1000./fScaleSail)/cxChildPixels;
  fYFeet =  yClick * (1000./fScaleSail)/cxChildPixels;

  for (iI = 1 ; iI <= iClicks ; iI++)
    {
    xClicks[iI - 1] = xClicks[iI] ;
    yClicks[iI - 1] = yClicks[iI] ;
    }
  iClicks-- ;

  if ((yClick < 0) && (!bParalax))
    {
    bParalax = TRUE ;
    SailPlan() ;
    bSailPlanIsChanged = TRUE ;
    return ;
    }

  bSail = FALSE ;
  for (iI = iNrSails-1 ; iI >= 0 ; iI--)
    {
    if (bBrig)
      iJ = iBrigSailSequence[4][iI] ;
    else
      iJ = iFrigateSailSequence[4][iI] ;
    switch (iSailType[iJ])
      {
      case 2:
        fOffsetX = fMastDistance[0] ; // foremast sails
        break ;
      case 4:
        fOffsetX = fMastDistance[1] ;  // mainmast sails
        break ;
      case 6:
        fOffsetX = fMastDistance[2] ;  // mizzenmast sails
        break ;
      case 1:
      case 3:
        fOffsetX = fSailTackDistance[iJ-(iSpanker+1)] ; // staysails
      }

    if (iJ > iSpanker)    
      {
      // allow for shape of jibs and staysails
      fX1 = fOffsetX + xSailPlanHeadLeft[iJ] ;
      fX2 = fOffsetX + xSailPlanFootLeft[iJ] ;
      fX3 = fOffsetX + xSailPlanFootRight[iJ] ;
      fY1 = ySailPlanHeadLeft[iJ] ;
      fY2 = ySailPlanFootLeft[iJ] ;
      fY3 = ySailPlanFootRight[iJ] ;
      f1 = fX1*fY2 - fY1*fX2 - fXFeet*fY2 + fYFeet*fX2 + fXFeet*fY1 - fYFeet*fX1 ;
      f2 = fX2*fY3 - fY2*fX3 - fXFeet*fY3 + fYFeet*fX3 + fXFeet*fY2 - fYFeet*fX2 ;
      f3 = fX3*fY1 - fY3*fX1 - fXFeet*fY1 + fYFeet*fX1 + fXFeet*fY3 - fYFeet*fX3 ;
      if ((Sgn(f1) == Sgn(f2)) && (Sgn(f2) == Sgn(f3)))
        {
        iThisSail = iJ ;
        bSail = TRUE ;
        break ;
        }
      }
    else
      {
      fX1 = fOffsetX + xSailPlanHeadLeft[iJ] ;
      fX2 = fOffsetX + xSailPlanHeadRight[iJ] ;
      fX3 = fOffsetX + xSailPlanFootRight[iJ] ;
      fX4 = fOffsetX + xSailPlanFootLeft[iJ] ;
      fY1 = ySailPlanHeadLeft[iJ] ;
      fY2 = ySailPlanHeadRight[iJ] ;
      fY3 = ySailPlanFootRight[iJ] ;
      fY4 = ySailPlanFootLeft[iJ] ;
      f1 = fX1*fY2 - fY1*fX2 - fXFeet*fY2 + fYFeet*fX2 + fXFeet*fY1 - fYFeet*fX1 ;
      f2 = fX2*fY3 - fY2*fX3 - fXFeet*fY3 + fYFeet*fX3 + fXFeet*fY2 - fYFeet*fX2 ;
      f3 = fX3*fY4 - fY3*fX4 - fXFeet*fY4 + fYFeet*fX4 + fXFeet*fY3 - fYFeet*fX3 ;
      f4 = fX4*fY1 - fY4*fX1 - fXFeet*fY1 + fYFeet*fX1 + fXFeet*fY4 - fYFeet*fX4 ;
      if ((Sgn(f1) == Sgn(f2)) && (Sgn(f2) == Sgn(f3)) && (Sgn(f3) == Sgn(f4)))
        {
        iThisSail = iJ ;
        bSail = TRUE ;
        break ;
        }
      }
    }

  if (!bSail)
    {
    strcpy (sMessage,"No sail selected") ;
    ShowMessage() ;
    return ;
    }

  iNrReefs = iSailMaxReefs[iThisSail] ;
  iThisStatus = iSailStatus[iThisSail] ;

  // check for eased sails
  if (bEasedJibs || bEasedStaySails)
    {
    if ((bEasedJibs) && (iSailType[iThisSail] = 1))
      {
      strcpy(sMessage, "Can't change when foresails are eased") ; 
      ShowMessage () ; 
      return ;
      }
    if ((bEasedStaySails) && (iSailType[iThisSail] = 3))
      {
      strcpy(sMessage, "Can't change when staysails are eased") ; 
      ShowMessage () ; 
      return ;
      }
    }

  // sail is blown uit
  if (iThisStatus == 5)
    {
    iSailStatus[iThisSail] = 4 ;
    sprintf(sMessage, "new %s bent", sSailName[iThisSail]) ; 
    ShowMessage () ; 
    if (bRecording)
      Recorder (9, iThisSail, iSailStatus[iThisSail]) ;
    SailPlan () ;
    CanShadow () ;
    return ;
    }

  if (iNrReefs == 0) 
    {
    // sail is not reefable
    if (iThisStatus == 4)
      {
      iSailStatus[iThisSail] = 0 ; // set
      sprintf(sMessage, "%s set", sSailName[iThisSail]) ; 
      ShowMessage () ; 
      }
    else
      {
      iSailStatus[iThisSail] = 4 ; // furled
      sprintf(sMessage, "%s furled", sSailName[iThisSail]) ; 
      ShowMessage () ; 
      if (iThisSail == iSpanker)
        {
        iNewYardAngle[3] = 0 ;
        SetScrollPos (hwndSlider[3], SB_CTL, -iNewYardAngle[3], TRUE) ;
        ShowSelectedYardAngle(3) ;
        }
      }
    }
  else
    {
    // sail is reefable
    fBorderLine = fSailEffectiveHead[iThisSail] ;
    if (iThisSail == iSpanker)
      fBorderLine = fBorderLine + (fSpankerPeak * (fOffsetX+xSailPlanHeadLeft[iThisSail]-fXFeet)/(xSailPlanHeadLeft[iThisSail]-xSailPlanHeadRight[iThisSail])) - fSpankerPeak ; 
    if (fYFeet < fBorderLine)
      {
      // reduce the sail
      if (iThisStatus == iNrReefs)
        {
        // all reefs are already taken in; // furl
        iSailStatus[iThisSail] = 4 ;
        sprintf(sMessage, "%s furled", sSailName[iThisSail]) ; 
        ShowMessage () ; 
        } 
      else
        {
        // take in reef
        if ((iThisStatus < iNrReefs) && (iThisStatus != 4))
          {
          sprintf(sMessage, "%s reefed", sSailName[iThisSail]) ; 
          ShowMessage () ; 
          iSailStatus[iThisSail] = iThisStatus + 1 ;
          } 
        else
          {
          sprintf(sMessage, "%s furled", sSailName[iThisSail]) ; 
          ShowMessage () ; 
          if (iThisSail == iSpanker)
            {
            iNewYardAngle[3] = 0 ;
            SetScrollPos (hwndSlider[3], SB_CTL, -iNewYardAngle[3], TRUE) ;
            ShowSelectedYardAngle(3) ;
            }
          }
        }
      }
    else
      {
      // let out reef
      if (iThisStatus > 0)
        {
        if (iThisStatus == 4)
          {
          // sail was furled
          iSailStatus[iThisSail] = iNrReefs ;
          sprintf(sMessage, "%s set close reefed", sSailName[iThisSail]) ; 
          ShowMessage () ; 
          }
        else
          {
          iSailStatus[iThisSail] = iThisStatus -1 ;
          sprintf(sMessage, "%s reef shaken out", sSailName[iThisSail]) ; 
          ShowMessage () ; 
          } 
        }  
      else
        { 
        sprintf(sMessage, "%s already set", sSailName[iThisSail]) ; 
        ShowMessage () ; 
        }
      }
    }

  if (bRecording)
    Recorder (9, iThisSail, iSailStatus[iThisSail]) ;

  // Recalculate effective head and mean heights of square sails (and spanker)
  for (iI = 0 ; iI <= iSpanker ; iI++)
   {
    fSailEffectiveHead[iI] = fSailFoot[iI] + fSailDepth[iI] * fSetFraction[iSailStatus[iI]] ;
    fSailMeanHeight[iI] = (fSailEffectiveHead[iI] + fSailFoot[iI]) / 2.0 ;
    if (iI == iSpanker)
      {
      // allow for difference between peak and nock of spanker
      fSailEffectiveHead[iI]=fSailEffectiveHead[iI] + fSpankerPeak ;
      fSailMeanHeight[iI] = ((fSailEffectiveHead[iI]-fSpankerPeak/2) + fSailFoot[iI]) / 2 ;
      } 
    } 

  // (de)activate change of jib in frigate
  if (iThisSail==12)
    {
    if (iSailStatus[12]==4)
      {  
      EnableWindow (hwndButton[7], TRUE) ;
      EnableWindow (hwndButton[8], TRUE) ;
      }
    else
      {
      EnableWindow (hwndButton[7], FALSE) ;
      EnableWindow (hwndButton[8], FALSE) ;
      }
    }

  bSailPlanIsChanged = TRUE ;
  CanShadow () ;
  if (iThisSail >= iSpanker)
    bPlanViewIsChanged = TRUE ;
  }

/*-----------------------------------------
   Beaufort
   Version date: 03.02.22
  -----------------------------------------*/
int Beaufort (float fWind)
  {

  if (fWind<1.0)
    return 0 ;
  if (fWind<4.0)
    return 1 ;
  if (fWind<7.0)
    return 2 ;
  if (fWind<11.0)
    return 3 ;
  if (fWind<17.0)
    return 4 ;
  if (fWind<22.0)
    return 5 ;
  if (fWind<28.0)
    return 6 ;
  if (fWind<34.0)
    return 7 ;
  if (fWind<41.0)
    return 8 ;
  if (fWind<48.0)
    return 9 ;
  if (fWind<56.0)
    return 10 ;
  if (fWind<65.0)
    return 11 ;
  return 12 ;
  }

/*-----------------------------------------
   DecrSail: Programmed decrease of sail
   Version date: 03.07.16
  -----------------------------------------*/
void DecrSail()
  {
  EnableWindow (hwndButton[2], TRUE) ;
  if (iMadeSail > 0 )
    {
    iMadeSail = iMadeSail - 1 ;
    if (bRecording)
      Recorder (3, iMadeSail, 0) ;
    MakeSail() ;
    } 
  if (iMadeSail == 0)
    EnableWindow (hwndButton[3], FALSE) ;
  SetFocus (hwndCheck[1]) ;
  }

/*-----------------------------------------
   IncrSail: Programmed increase of sail
   Version date: 03.09.03
  -----------------------------------------*/
void IncrSail()
  {
  int iMaxSail ;

  if (bBrig)
    iMaxSail = 15 ;
  else
    iMaxSail = 8 ;
  EnableWindow (hwndButton[3], TRUE) ;
  if (iMadeSail < iMaxSail )
    {
    iMadeSail = iMadeSail + 1 ;
    if (bRecording)
      Recorder (3, iMadeSail, 0) ;
    MakeSail() ;
    } 
  if (iMadeSail == iMaxSail)
    EnableWindow (hwndButton[2], FALSE) ;
  SetFocus (hwndCheck[1]) ;
  }

/*-----------------------------------------
   MakeSail: Programmed sail status
   Version date: 03.09.03
  -----------------------------------------*/
void MakeSail()
  {
  int    iI ;

  if (bBrig)
    {
    switch (iMadeSail)
      {
      case 15 : // John 14
        iSailStatus[0] = 0 ;
        iSailStatus[1] = 0 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 0 ;
        iSailStatus[6] = 0 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 0 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 0 ;
        iSailStatus[16] = 0 ;
        iSailStatus[17] = 0 ;
        break ;
      case 14 : // John 13
        iSailStatus[0] = 0 ;
        iSailStatus[1] = 0 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 0 ;
        iSailStatus[6] = 0 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 0 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 0 ;
        break ;
      case 13 : // John 12
        iSailStatus[0] = 0 ;
        iSailStatus[1] = 0 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 0 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 0 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 0 ;
        break ;
      case 12 : // John 11
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 0 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 0 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 0 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 0 ;
        break ;
      case 11 : // John 10
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 0 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 0 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 0 ;
        break ;
      case 10 : // John 9
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 0 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 0 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 0 ;
        break ;
      case 9 : // John 8
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 0 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 0 ;
        break ;
      case 8 : // John 7
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 0 ;
        break ;
      case 7 : // John 6
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 0 ;
        break ;
      case 6 : // John 5
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 4 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 0 ;
        break ;
      case 5 : // John 4
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 4 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 0 ;
        iSailStatus[13] = 0 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 4 ;
        break ;
      case 4 : // John 3
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 4 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 4 ;
        iSailStatus[13] = 4 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 4 ;
        break ;
      case 3 : // John 3
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 4 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 4 ;
        iSailStatus[13] = 4 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 4 ;
        break ;
      case 2 : // John 2
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 4 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 4 ;
        iSailStatus[13] = 4 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 4 ;
        break ;
      case 1 : // John 1
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 4 ;
        iSailStatus[3] = 4 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 4 ;
        iSailStatus[13] = 4 ;
        iSailStatus[14] = 0 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 4 ;
        break ;
      case 0 :
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 4 ;
        iSailStatus[3] = 4 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 4 ;
        iSailStatus[13] = 4 ;
        iSailStatus[14] = 4 ;
        iSailStatus[15] = 4 ;
        iSailStatus[16] = 4 ;
        iSailStatus[17] = 4 ;
        break ;
      }
    }
  else
    {    
    switch (iMadeSail)
      {
      case 8 :
        iSailStatus[0] = 0 ;
        iSailStatus[1] = 0 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 0 ;
        iSailStatus[5] = 0 ;
        iSailStatus[6] = 0 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 0 ;
        iSailStatus[9] = 0 ;
        iSailStatus[10] = 0 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iJibSet = 0 ;
        break ;
      case 7 :
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 0 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 0 ;
        iSailStatus[6] = 0 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 0 ;
        iSailStatus[10] = 0 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iJibSet = 0 ;
        break ;
      case 6 :
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 0 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 0 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 0 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iJibSet = 1 ;
        break ;
      case 5 :
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 1 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 1 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 1 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iJibSet = 1 ;
        break ;
      case 4 :
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 2 ;
        iSailStatus[3] = 0 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 2 ;
        iSailStatus[7] = 0 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 3 ;
        iSailStatus[11] = 0 ;
        iSailStatus[12] = 0 ;
        iJibSet = 1 ;
        break ;
      case 3 :
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 2 ;
        iSailStatus[3] = 1 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 2 ;
        iSailStatus[7] = 1 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 3 ;
        iSailStatus[11] = 1 ;
        iSailStatus[12] = 0 ;
        iJibSet = 1 ;
        break ;
      case 2 :
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 3 ;
        iSailStatus[3] = 1 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 3 ;
        iSailStatus[7] = 1 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 1 ;
        iSailStatus[12] = 0 ;
        iJibSet = 2 ;
        break ;
      case 1 :
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 3 ;
        iSailStatus[3] = 4 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 2 ;
        iSailStatus[12] = 0 ;
        iJibSet = 2 ;
        break ;
      case 0 :
        iSailStatus[0] = 4 ;
        iSailStatus[1] = 4 ;
        iSailStatus[2] = 4 ;
        iSailStatus[3] = 4 ;
        iSailStatus[4] = 4 ;
        iSailStatus[5] = 4 ;
        iSailStatus[6] = 4 ;
        iSailStatus[7] = 4 ;
        iSailStatus[8] = 4 ;
        iSailStatus[9] = 4 ;
        iSailStatus[10] = 4 ;
        iSailStatus[11] = 4 ;
        iSailStatus[12] = 4 ;
        iJibSet = 2 ;
      }
    NewJib () ;
    if (iSailStatus[12]==4)  // jib reefed
      fSailAngle[12] = 0. ; // haul in jib upon furling
    ShowActualJibAngle () ;
    }

  // adjust effective heights of square sails
  for (iI = 0 ; iI <= iSpanker ; iI++)
   {
    fSailEffectiveHead[iI] = fSailFoot[iI] + fSailDepth[iI] * fSetFraction[iSailStatus[iI]] ;
    fSailMeanHeight[iI] = (fSailEffectiveHead[iI] + fSailFoot[iI]) / 2.0 ;
    if (iI == iSpanker)
      {
      // allow for difference between peak and nock of spanker
      fSailEffectiveHead[iI]=fSailEffectiveHead[iI] + fSpankerPeak ;
      fSailMeanHeight[iI] = ((fSailEffectiveHead[iI]-fSpankerPeak/2) + fSailFoot[iI]) / 2 ;
      } 
   } 
  bPlanViewIsChanged = TRUE ;
  SailPlan () ;
  CanShadow () ;

  }

/*-----------------------------------------
   Pause
   Version date: 03.07.19
  -----------------------------------------*/
void Pause()
  {
  if (!bPaused)
    {
    bPaused = TRUE ;
    SetWindowText(hwndButton[6], "Restart") ;
    fPauseTime = fLastTime ;
    }
  else
    {
    bPaused = FALSE ;
    SetWindowText(hwndButton[6], "Pause") ;
    if (liFrequency.QuadPart == 0)
      fLastTime = (float) clock()/CLOCKS_PER_SEC ;
    else
      {
      QueryPerformanceCounter (&liCounter) ;
      fLastTime = (float) (liCounter.QuadPart / (float) liFrequency.QuadPart) ;
      }
    if (bRecording || bPlayBack)
      fRecordStartTime = fRecordStartTime + (fLastTime-fPauseTime) ;
    }

  SetFocus (hwndCheck[1]) ;
  }

/*-----------------------------------------
   ShowMessage
   Version date: 03.03.16
  -----------------------------------------*/
void ShowMessage ()
  {
  HDC   hdc ;
  int   iI, iJ ;
  SIZE  size ;

  hdc=GetDC (hwnd) ;
  iMessageNr++ ;
  if (iMessageNr == 6)
    {
    // scroll first message off screen
    for (iI = 0 ; iI<=4 ; iI++)
      { 
      strcpy(sShipMessage[iI],sShipMessage[iI+1]) ;
      fMessageTime[iI] = fMessageTime[iI + 1] ;
      SelectObject (hdc,GetStockObject(NULL_PEN)) ;
      Rectangle (hdc, xMessage, yMessage+ iI*cyTextHeight, xMessage+cxMessage-2, 
        yMessage + (iI+2)*cyTextHeight) ;
      SelectObject (hdc,GetStockObject(BLACK_PEN)) ;
      TextOut (hdc, xMessage, yMessage+ iI*cyTextHeight, sShipMessage[iI], strlen(sShipMessage[iI])) ; 
      } 
    iMessageNr = 5 ;
    }
  GetTextExtentPoint32(hdc,sMessage,strlen(sMessage),&size) ;

  if (size.cx > cxMessage-4)
    {
    int   iPlace;
    char  sMessage_1[120] ; 
    char  sTemp[120] ; 
    
    if (iMessageNr == 5)
      {
      // scroll another message off screen
      for (iI = 0 ; iI<=3 ; iI++)
        { 
        strcpy(sShipMessage[iI],sShipMessage[iI+1]) ;
        fMessageTime[iI] = fMessageTime[iI + 1] ;
        SelectObject (hdc,GetStockObject(NULL_PEN)) ;
        Rectangle (hdc, xMessage, yMessage+ iI*cyTextHeight, xMessage+cxMessage-2, 
          yMessage + (iI+2)*cyTextHeight) ;
        SelectObject (hdc,GetStockObject(BLACK_PEN)) ;
        TextOut (hdc, xMessage, yMessage+ iI*cyTextHeight, sShipMessage[iI], strlen(sShipMessage[iI])) ; 
        } 
      iMessageNr = 4 ;
      }
    strcpy(sMessage_1,sMessage) ;
    iPlace = 0 ;
    for (iI=2 ; iI<strlen(sMessage_1) ; iI++)
      {
      if (sMessage_1[iI] == ' ')
        {
        for (iJ=0 ; iJ<iI ; iJ++)
          sTemp[iJ]=sMessage_1[iJ] ; 
        sTemp[iI]='\0' ;
        GetTextExtentPoint32(hdc,sTemp,strlen(sTemp),&size) ;
        if (size.cx > cxMessage-4)
          break ;
        iPlace = iI ;
        }
      }
    strcpy (sMessage,sMessage_1) ;
    sMessage[iPlace]='\0' ;
    strcpy (sShipMessage[iMessageNr],sMessage) ;
    fMessageTime[iMessageNr] = fNow ;
    SelectObject (hdc,GetStockObject(NULL_PEN)) ;
    Rectangle (hdc, xMessage, yMessage+ iMessageNr*cyTextHeight, xMessage+cxMessage-2, 
      yMessage + (iMessageNr+1)*cyTextHeight) ;
    SelectObject (hdc,GetStockObject(BLACK_PEN)) ;
    TextOut (hdc, xMessage, yMessage+ iMessageNr*cyTextHeight, sShipMessage[iMessageNr], strlen(sShipMessage[iMessageNr])) ; 
    iMessageNr++ ;
    iJ=0 ;
    for (iI=iPlace ; iI<strlen(sMessage_1) ; iI++)
      {
      sMessage[iJ]=sMessage_1[iI] ; 
      iJ++ ;
      }
    sMessage[iJ]='\0' ;
    }
  
  strcpy (sShipMessage[iMessageNr],sMessage) ;
  fMessageTime[iMessageNr] = fNow ;
  SelectObject (hdc,GetStockObject(NULL_PEN)) ;
  Rectangle (hdc, xMessage, yMessage+ iMessageNr*cyTextHeight, xMessage+cxMessage-2, 
    yMessage + (iMessageNr+1)*cyTextHeight) ;
  SelectObject (hdc,GetStockObject(BLACK_PEN)) ;
  TextOut (hdc, xMessage, yMessage+ iMessageNr*cyTextHeight, sShipMessage[iMessageNr], strlen(sShipMessage[iMessageNr])) ; 
  MessageBeep(0) ;
  ReleaseDC (hwnd, hdc) ;
  }

/*-----------------------------------------
   ShowStatusMessage
   Version date: 00.06.10
  -----------------------------------------*/
void ShowStatusMessage()
  {
  HDC        hdc ;
  LPRECT     lprect ;
  RECT       rect ;

  hdc=GetDC (hwndStatus) ;
  SelectObject(hdc, MyFont) ;
  GetClientRect (hwndStatus, &rect) ;
  lprect= &rect ;
  DrawStatusText(hdc,lprect,sMessage, 0);
  ReleaseDC (hwndStatus,hdc) ;
  return ;
  }

/*-----------------------------------------
   ShowYardShown
   Version date: 99.04.25
  -----------------------------------------*/
void ShowYardShown()
  {
  HDC   hdc ;
  SIZE  size ;

  hdc=GetDC (hwnd) ;
  SelectObject(hdc,GetStockObject(NULL_PEN)) ;
  Rectangle (hdc, 5, 4, 100, 18) ;
  SelectObject(hdc, hSkyBrush) ;
  SetBkMode(hdc, TRANSPARENT) ;
  GetTextExtentPoint32(hdc,sYardLevel[iYardLevelShown],strlen(sYardLevel[iYardLevelShown]),
    &size) ; 
  Rectangle (hdc, 5, 4, 8 + size.cx, 18) ;
  SelectObject(hdc,GetStockObject(BLACK_PEN)) ;
  TextOut (hdc, 6, 4, sYardLevel[iYardLevelShown], strlen(sYardLevel[iYardLevelShown])) ;
  SetBkMode(hdc, OPAQUE) ;
  SelectObject(hdc, GetStockObject(LTGRAY_BRUSH)) ;
  ReleaseDC (hwnd, hdc) ;
  }

